#!/usr/bin/python
# -*- coding: utf-8 -*-

#ddispersion.py

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
from rpy import *

nombre=u"Diagrama de dispersión"
tipo="Graficos"

def funcion(dato,ejes,opciones): 
	diccionario={}
	variable1=ejes["EJEX"]
	variable2=ejes["EJEY"]
	lista1=[float(x) for x in dato[variable1]]
	lista2=[float(x) for x in dato[variable2]]
	import random
	nombrefichero="/tmp/driza"+str(random.randint(1,99999))+".png"
	diccionario["ruta"]=nombrefichero
	r.png(nombrefichero) #Directorio temporal de la config
	r.require("car")
	r.scatterplot(lista1,lista2,reg_line=False,labels=False,smooth=False,span=0.5)
	r.dev_off()
	return diccionario

def initresultado(resultado,opciones):
	"""Inicializa al objeto resultado, añadiendole lo que crea conveniente"""
	resultado.addImagen("resultado")
	resultado["resultado"].titulo=u"Diagrama de dispersión"


def interfazresultado(resultado,variable,diccionario):
	"""Este método dice como introducir los datos en la tabla"""
	resultado["resultado"].set(diccionario["ruta"])

diccionarioopciones={}
diccionariograficosy={"nombre":"EJEY","tipo":"Variables"}
diccionariograficosx={"nombre":"EJEX","tipo":"Variables"}

widget={"tipo":"Graficos","opciones":[diccionarioopciones],"graficos":[diccionariograficosy,diccionariograficosx]}



