#!/usr/bin/python
# -*- coding: utf-8 -*-

#regresion.py Operación Regresión

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
from rpy import *

nombre=u"Regresión"
tipo="Calculo"

def funcion(dato,variable,caso,opciones):  # Cambiar cosa por caso
	variable1 = variable[0].latin1() # Sin Qstring
	variable2 = variable[1].latin1() # Sin Qstring
	lista1=[float(x) for x in dato.getCol(variable1,caso=caso)]
	lista2=[float(x) for x in dato.getCol(variable2,caso=caso)]
	#resultadoprueba=r.lm(r("y ~ x"),data=r.data_frame(x=lista1, y=lista2))
	#sumario=r.summary_lm(resultadoprueba,True)
	resultadoprueba=r.lsfit(lista1,lista2)
	return resultadoprueba

def initresultado(resultado,opciones):
	"""Inicializa al objeto resultado, añadiendole lo que crea conveniente"""
	resultado.addTablaDoble("resultado")
	resultado["resultado"].titulo=u"Regresión Lineal"
	lista=[]
	if opciones["caso"]:
		lista.append("Caso")
	lista+=["m","b"]
	resultado["resultado"].settitulo(lista)


def interfazresultado(resultado,listaopciones):
	"""Este método dice como introducir los datos en la tabla"""
	#Falta coeficiente de correlacion r
	#Falta coeficiente de determinacion r^2
	#Afinar parametros de la recta
	#Significacion
	#Hay un anova sipmple que determina si la recta se cumple
	lista=[]
	variables=listaopciones[0]
	caso=listaopciones[1]
	diccionario=listaopciones[2]
	if caso:
		lista.append(caso)
	lista+=[diccionario['coefficients']['X'],diccionario['coefficients']['Intercept']]
	resultado["resultado"].set(variables,lista)

diccionarioopciones={}
widget={"tipo":"CalculoDoble","opciones":diccionarioopciones}



