#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#excepciones.py: Todas las excepciones definidas para el programa

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import exceptions

#Excepcion para fichero existente

class FicheroExisteException(Exception):
	"""Define la excepcion que sera lanzada cuando se intente escribir un fichero existente"""
	def __init__(self,nombrefichero):
		self.fichero=nombrefichero

class VariableExisteException(Exception):
	"""A la hora de añadir una nueva variable en los datos, indica que ya existe"""
	pass



class TipoIncorrectoException(Exception):
	"""excepcion para argumentos de tipo incorrecto en las funciones"""
	def __init__(self,tipoesperado,tiporecibido):
		self.tipoesperado=tipoesperado
		self.tiporecibido=tiporecibido
